function SB_setup()
{
	$SB_Setup = true;
	if(isObject(SB_searchResults))
	{
		SB_searchResults.delete();
		SB_searchBox.delete();
		SB_searchBoxGo.delete();
	}
	if(!isObject(SB_searchResults))
	{
		%scroll = new GuiScrollCtrl(SB_searchResults)
		{
			profile = BSDScrollProfile;
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			defaultLineHeight = 32;
			extent = "634 363";
			rowHeight = 40;
			visible = false;
		};
		BSD_ScrollBox.add(%scroll);

		%resultBox = new GuiBitmapCtrl(SB_searchResultsBox)
		{
			profile = "ColorScrollProfile";
			extent = "634 363";
			position = "0 0";
			color = "0 0 0 0";
		};
		%scroll.add(%resultBox);
		%scroll.resultBox = %resultBox;

		if(isObject(SB_searchBox))
			SB_searchBox.delete();

		%searchBox = new GuiTextEditCtrl(SB_searchBox)
		{
			profile = "SB_TextEditProfile";
			position = "470 3";
			extent = "60 19";
			command = "SB_search(SB_searchBox.getValue());";
			altCommand = "SB_search(SB_searchBox.getValue());";
			accelerator = "enter";
		};

		%searchGo = new GuiBitmapButtonCtrl(SB_searchBoxGo)
		{
			profile = "BlockButtonProfile";
			bitmap = "Add-Ons/Client_SearchBricks/buttonSearch2";
			position = "529 3";
			extent = "16 19";
			text = ">";
			command = "SB_search(SB_searchBox.getValue());";
		};

		
		BSD_Window.add(%searchGo);
		BSD_Window.add(%searchBox);
		%brickList = new GuiTextListCtrl(SB_BrickList);
	}
	%brickCount = 0;
	SB_searchResultsBox.clear();
	SB_BrickList.clear();
	for(%i=0; %i < BSD_ScrollBox.getCount(); %i++)
	{
		%scroll = BSD_ScrollBox.getObject(%i).getObject(0);
		if(!isObject(%scroll))
			continue;
		for(%j=0; %j < %scroll.getCount(); %j++)
		{
			%brick = %scroll.getObject(%j);
			if(%brick.getClassName() $= "GuiBitmapButtonCtrl")
			{
				%foundBrick = StrReplace(%brick.command, "BSD_ClickIcon(", "");
				%foundBrick = StrReplace(%foundBrick, ");", "");

				if(!isObject(%foundBrick))
					continue;

				%bitmap = %foundBrick.iconName;
				if(!isFile(%bitmap))
						%bitmap = "base/client/ui/brickIcons/unknown";
				SB_BrickList.addRow(%brickCount++, %foundBrick TAB %foundBrick.uiName);
			}
		}
	}
	SB_BrickList.sort(1, 1);

	%label = new GuiTextCtrl()
	{
		profile = "BrickListSubCategoryProfile";
		position = "28 -2";
		text = "Search Results";
		extent = "100 18";
		doNotDelete = true;
	};
	SB_searchResultsBox.add(%label);

	%bar = new GuiBitmapCtrl()
	{
		position = "18 15";
		extent = "581 2";
		doNotDelete = true;
	};
	SB_searchResultsBox.add(%bar);

	for(%i=0; %i < SB_BrickList.rowCount(); %i++)
	{
		%row = SB_BrickList.getRowText(%i);
		%brick = getField(%row, 0);

		%back = new GuiBitmapCtrl()
		{
			profile = "BlockDefaultProfile";
			position = "18 18";
			extent = "96 96";
			bitmap = "base/client/ui/brickicons/brickiconbg";
			visible = false;
			brick = %brick;
		};
		
		%bitmap = %brick.iconName;
		if(!isFile(%bitmap))
			%bitmap = "base/client/ui/brickIcons/unknown";

		%img = new GuiBitmapCtrl()
		{
			profile = "BlockDefaultProfile";
			extent = "96 96";
			bitmap = %bitmap;
		};
		%back.add(%img);
		
		%button = new GuiBitmapButtonCtrl()
		{
			text = "";
			extent = "96 96";
			bitmap = "base/client/ui/brickicons/brickIconBtn";
			command = "BSD_ClickIcon(" @ %brick @ ");";
			altCommand = "BSD_RightClickIcon(" @ %brick @ ");";
		};
		%back.add(%button);
		
		%label = new GuiTextCtrl()
		{
			profile = "HUDBSDNameProfile";
			position = "0 78";
			extent = "96 18";
			text = %brick.uiName;
		};
		
		%back.add(%label);
		SB_searchResultsBox.add(%back);
	}
}


function SB_showSearch()
{
	for(%i=0; %i < $BSD_numCategories; %i++)
		$BSD_category[%i].Scroll.setVisible(0);

	SB_searchResults.setVisible(true);

	for(%i=0; %i < BSD_TabBox.getCount(); %i++)
	{
		%tab = BSD_TabBox.getObject(%i);
		%tab.setBitmap("base/client/ui/tab1");
	}
}

function SB_search(%text)
{
	SB_showSearch();
	SB_searchResults.scrollToTop();
	%text = strLwr(%text);

	%numBricks = 0;
	for(%i=0; %i < SB_searchResultsBox.getCount(); %i++)
	{
		%currBrick = SB_searchResultsBox.getObject(%i);
		
		if(%currBrick.doNotDelete)
			continue;
		
		if(strStr(strLwr(%currBrick.brick.uiName), %text) == -1 && strStr(strLwr(%currBrick.brick.subCategory), %text) == -1)
		{
			%currBrick.setVisible(false);
			continue;
		}
		else
			%currBrick.setVisible(true);

		%currBrick.position = mFloor( ((%numBricks % 6) * 97) + 17) SPC mFloor(%numBricks / 6) * 97 + 18;
		%numBricks++; 
	}

	%yExt = mFloor(%numBricks / 6) * 97 + 18;
	if(%numBricks % 6 != 0)
		%yExt += 98;
	SB_searchResultsBox.resize(0, 0, 634, %yExt);
}

function SB_toggleSearchFocus(%on)
{
	if(!%on)
		return;

	if(SB_searchBox.hasFocus)
	{
		SB_searchBox.hasFocus = false;
		SB_searchBox.makeFirstResponder(false);
	}
	else
	{
		SB_searchBox.hasFocus = true;
		SB_searchBox.makeFirstResponder(true);
	}
}

if(!isObject(SB_TextEditProfile)) new GuiControlProfile(SB_TextEditProfile : GuiTextEditProfile)
{
	canKeyFocus = true;
	textOffset = "0 0";
	opague = false;
	fillColor = "210 210 210 255";
	fontSize = 13;
	borderColor = "160 160 160 255";
};

package SearchBricks
{
	function BSD_ShowTab(%catID)
	{
		if(isObject(SB_searchResults))
			SB_searchResults.setVisible(false);
		parent::BSD_ShowTab(%catID);
	}

	function BrickSelectorDlg::onWake(%this)
	{
		if(!$SB_Setup)
			SB_setup();

		SB_searchBox.extent = "60 19";
		SB_searchBox.hasFocus = false;
		%this.SB_oldBind = moveMap.getCommand(keyboard, "ctrl return");
		moveMap.bind(keyboard, "ctrl return", SB_toggleSearchFocus);
		parent::onWake(%this);
		SB_searchBox.schedule(0, makeFirstResponder, false);
	}

	function BrickSelectorDlg::onSleep(%this)
	{
		moveMap.bind(keyboard, "ctrl return", %this.SB_oldBind);
		parent::onSleep(%this);
	}

	function BSD_KillBricks()
	{
		$SB_Setup = false;
		return parent::BSD_KillBricks();
	}

	function BSD_ClickIcon(%data)
	{
		SB_searchBox.makeFirstResponder(false);
		return parent::BSD_ClickIcon(%data);
	}
};
activatePackage(SearchBricks);